using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Shared;
using System.Text;
using System.Data.OleDb;

namespace Page_Refresh_Sample
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.Label Label1;
		
		//Create a new PDF Document. The pdfDoc object represents the PDF document.
		//This document has one page by default and additional pages have to be added.
		PDFDocument pdfDoc = new PDFDocument();

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			string path=Server.MapPath("Northwind.mdb");
			OleDbConnection Conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source="+path);	
			//Values in the grid before refresh.
			OleDbDataAdapter Cmd = new OleDbDataAdapter("select * from Categories", Conn);
			DataSet ds = new DataSet();
			Conn.Open();
			Cmd.Fill(ds, "Categories");
			DataTable dt = ds.Tables["Categories"];
			DataGrid1.DataSource = dt;
			DataGrid1.DataBind();	
			Conn.Close();

			
			pdfDoc.ViewerPreferences.HideToolbar =true;
			pdfDoc.ViewerPreferences.HideWindowUI  =true;
			//Adding a font that can be used to draw Text inside the PDF document.
			//Using the Predefined fonts to draw the text. 
			IPDFFont pdfFont = pdfDoc.Fonts.Add( FontBaseFamily.Courier );
			//Access the first page in the PDFDocuments's pages collection
			IPDFPage firstPage = pdfDoc.Pages[0];
			//Draw text at the specified Location.
			//Note:This will be dispalyed before the page refresh
			firstPage.Graphics.DrawText(0,0,"Hello World!",pdfFont);
			
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Button1_Click(object sender, System.EventArgs e)
		{
			callpagerefresh();
			
			ITable table = pdfDoc.CreateTable();
			IPDFFont customersTableTitleFont = pdfDoc.Fonts.Add( new Font( "courier", 10, FontStyle.Bold )  );
			IPDFFont customersTableBodyFont = pdfDoc.Fonts.Add( new Font( "courier", 10, FontStyle.Regular )  );
	
			table.DataSource = DataGrid1.DataSource;
			
			table.ConfigureTable(DataGrid1.DataSource as DataTable);
			for( int i = 0, len = table.Columns.Count; i < len; ++i )
			{
				table.Header[0].Cells[i].Style.BackColor = Color.FromArgb( 252, 172, 38 );
				table.Header[0].Cells[i].Style.TextFont = customersTableTitleFont;
				table.Header[0].Cells[i].Style.BorderColors.All = Color.FromArgb( 0x82, 0x2e, 0x1b );
				
			}
			
			//Format the tables
			for( int i = 0; i < table.Rows.Count; ++i )
			{
				for(int j=0; j< table.Columns.Count;++j)
				{
					table.Rows[i].Cells[j].Style.BackColor = Color.FromArgb( 219, 226, 242 );
					table.Rows[i].Cells[j].Style.TextFont = customersTableBodyFont;
					table.Rows[i].Cells[j].Style.BorderColors.All = Color.FromArgb( 0x82, 0x2e, 0x1b );
					
				}
			}
			for( int i = 0, len = table.Columns.Count; i < len; ++i )
			{
				table.Columns[ i ].Width = 100;
			}		

			//Update the pdf document with the refreshed page content.
			table.Publish( new PointF( 0, 20 ),pdfDoc.Pages[0]);
			
			// Create a session to pdf document object and pass it to PDFForm.aspx
			Session["PDF"]=pdfDoc;

			//To call load startup script to load in new browser window
			Page.RegisterClientScriptBlock("x",LoadStartupScript());

			//callpagerefresh();
			Label1.Text="success";
		}
		
		//Some database manipulations to show that page is being refreshed
		public void callpagerefresh()
		{
			
			string path=Server.MapPath("Northwind.mdb");
			OleDbConnection Conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source="+path);
			string ocommand = "update Categories set pageviewed = pageviewed+1";
			
			Conn.Open();
			OleDbCommand oCommand = new OleDbCommand(ocommand, Conn);
			oCommand.CommandType = CommandType.Text;
			OleDbDataReader objDR1 = oCommand.ExecuteReader();
			Conn.Close();
			
			OleDbDataAdapter Cmd = new OleDbDataAdapter("select * from Categories", Conn);
			DataSet ds = new DataSet();
			Conn.Open();
			Cmd.Fill(ds, "Categories");
			DataTable dt = ds.Tables["Categories"];
			DataGrid1.DataSource = dt;
			DataGrid1.DataBind();	
			Response.Write("This page has been refreshed, Values in pageviewed column has been updated!");
		}

		//Java scripts 
		private string LoadStartupScript()
		{
			// Create a new string builder class
			StringBuilder stb = new StringBuilder();
			//Stream script to open in new window
			stb.Append("\n<script language=\"javascript\">\n<!--\n");
			
			//Open the PDF document in the new web form[PDFForm.aspx]
			stb.Append("window.open(\"PDFForm.aspx\",\"_blank\",\"toolbar=1\")");
			stb.Append("\n// -->\n</script>\n");
			return stb.ToString();

		}
		
		
	}
}
